"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var seedrandom_1 = __importDefault(require("seedrandom"));
var rng_1 = __importDefault(require("./rng"));
var function_1 = __importDefault(require("./generators/function"));
/**
 * Construct an RNG with variable inputs. Used in calls to Random constructor
 * @param {...*} args - Distribution-specific arguments
 * @return RNG
 *
 * @example
 * new Random(RNGFactory(...args))
 */
exports.default = (function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var _a = args[0], arg0 = _a === void 0 ? 'default' : _a, rest = args.slice(1);
    switch (typeof arg0) {
        case 'object':
            if (arg0 instanceof rng_1.default) {
                return arg0;
            }
            break;
        case 'function':
            return new function_1.default(arg0);
        case 'number':
        case 'string':
            return new function_1.default(seedrandom_1.default.apply(void 0, rest));
    }
    throw new Error("invalid RNG \"" + arg0 + "\"");
});
//# sourceMappingURL=rng-factory.js.map